#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include "validate.h"
using namespace std;


const int MAX_N = 505;
const int MAX_L = 10005;
vector<string> words(MAX_N);
vector<vector<int>> pref(MAX_N,vector<int>(MAX_L,MAX_L)); 
vector<int> maxInCol(MAX_L,-1);


int main(int argc, char **argv) 
{
	init_io(argc,argv);

	int res_l, res_r;
	judge_ans >> res_l >> res_r;
	int res_len = res_r - res_l + 1;

	int author_l,author_r; 
	author_out >> author_l >> author_r;
	int author_len = author_r - author_l + 1;

	if(author_out.fail())
		wrong_answer("WA: team did not output two integers");

	// team's output matches exactly the judge's outputs
	if (author_l == res_l && author_r == res_r)
		accept();

	// team's substring is longer than the expected on
	if (author_len > res_len)
		wrong_answer("WA: team's substring is too long");

	// team's substring is shorter than the expected on
	if (author_len > res_len)
		wrong_answer("WA: team's substring is too short");

	
	int n,l; judge_in >> n >> l;
	for (int i = 0; i < n; ++i)
		judge_in >> words[i];
	for (int i = 0; i < n-1; ++i)
	{
		string &x = words[i];
		string &y = words[i+1];
		vector<int> &z = pref[i];
		for (int j = l-1; j >= 0; --j)
		{
			if (x[j] < y[j])
				z[j] = 1;
			else if (x[j] == y[j] && j != l-1 && z[j+1] != MAX_L)
				z[j] = z[j+1] + 1;
		}
	}
	for (int i = 0; i < l; ++i)
		for (int j = 0; j < n-1; ++j)
			maxInCol[i] = max(maxInCol[i],pref[j][i]);

	if (maxInCol[author_l-1] == MAX_L)
		wrong_answer("WA: there does not exist a valid substring starting at the team's index i");

	if (maxInCol[author_l-1] > maxInCol[res_l-1])
		wrong_answer("WA: the substring starting at the team's index i is not optimal because there exists a shorter substring");

	int expected_r = author_l + maxInCol[author_l-1] - 1;
	if (maxInCol[author_l-1] == maxInCol[res_l-1] && author_r < expected_r)
		wrong_answer("WA: the team's substring starts at a correct index but is too short");

	if (maxInCol[author_l-1] == maxInCol[res_l-1] && author_r > expected_r)
		wrong_answer("WA: the team's substring starts at a correct index but is too long");

	// check for trailing output
	string trailing;
	if(author_out >> trailing)
		wrong_answer("WA: trailing output");

	accept();
}
