#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int count_connected(vector<vector<char>> &color, vector<vector<int>> &time, 
	int k, int r, int c, int dr, int dc)
{
	int numConnected = 0;
	for (int i = 1; i < k; ++i)
	{
		int rr = r + i * dr;
		int cc = c + i * dc;
		if (rr < 0 || rr >= color.size() || cc < 0 || cc >= color[0].size() 
			|| color[r][c] != color[rr][cc] || time[r][c] < time[rr][cc])
			break;
		numConnected++;
	}
	return numConnected;
}

int main()
{
	int h,w,k; cin >> h >> w >> k;
	vector<vector<char>> color(h,vector<char>(w));
	vector<vector<int>> time(h,vector<int>(w));
	vector<int> colheight(w,h-1);
	for (int i = 0; i < h*w; ++i) 
	{
		int c; cin >> c; c--;
		int r = colheight[c]--;
		color[r][c] = 65 + i % 2;
		time[r][c] = i;
	}
	int minMove = 1e9;
	int winner = 'D';
	for (int i = 0; i < h; ++i)
	{
		for (int j = 0; j < w; ++j)
		{
			if (time[i][j] > minMove) continue;
			if (1 + count_connected(color,time,k,i,j,0,1) + count_connected(color,time,k,i,j,0,-1) >= k
				|| 1 + count_connected(color,time,k,i,j,1,0) + count_connected(color,time,k,i,j,-1,0) >= k 
				|| 1 + count_connected(color,time,k,i,j,1,1) + count_connected(color,time,k,i,j,-1,-1) >= k
				|| 1 + count_connected(color,time,k,i,j,-1,1) + count_connected(color,time,k,i,j,1,-1) >= k)
			{
				minMove = time[i][j];
				winner = color[i][j];
			}
		}
	}
	if (winner == 'D') cout << "D" << endl;
	else cout << (char) winner << " " << minMove+1 << endl;
}

