#!/usr/bin/env pypy3

import sys

if __name__ == "__main__":
    n, x, y = map(int, sys.stdin.readline().split(" "))
    books = [tuple(map(int, sys.stdin.readline().split(" "))) for _ in range(n)]
    max_height = max(h for _, h in books)
    total_width = sum(w for w, _ in books)

    if max_height > y:
        print("impossible")
        sys.exit(0)
    if total_width <= x:
        print(-1)
        sys.exit(0)

    upper_height = y - max_height
    greedy_width = sum(w for w, h in books if h > upper_height)
    if greedy_width > x:
        print("impossible")
        sys.exit(0)

    remaining_books = [w for w, h in books if h <= upper_height]
    remaining_width = sum(remaining_books)
    remaining_lower_space = x - greedy_width

    reachable = {0}
    for w in remaining_books:
        reachable.update([r + w for r in reachable if r + w <= remaining_width])
    lower_width = max(reachable)
    if remaining_width - lower_width <= x:
        print(max_height)
    else:
        print("impossible")
